%define	name	drakxtools
%define	version	11.16tiny
%define	realver	11.16
%define	release	%mkrel 5

Summary:	The drakxtools (diskdrake, ...)
Name:		%{name}
Version:	%{version}
Release:	%{release}
Url:		http://wiki.mandriva.com/Development/Docs/drakxtools_dev
License:	GPLv2+
Group:		System/Configuration/Other
Packager:	KDulcimer <kdulcimer@gmail.com>
BuildRoot:	%{_tmppath}/%{name}-buildroot
Source0:	%{name}-%{realver}.tar.bz2
Source1:	do_pkgs.pm

Patch1:		tinyme-any.pm.patch
Patch2:		authentication.pm.patch
Patch3:		tinyme-bootloader.pm.patch
Patch4:		bootsplash.pm.patch
Patch5:		do_pkgs.pm.patch
Patch6:		tinyme-messages.pm.patch
Patch7:		standalone.pm.patch
Patch8:		x-drakfont.patch
Patch9:		x-drakhelp.patch
Patch10:	x-draksound.patch
Patch11:	x-drakxtv.patch
Patch12:	x-harddrake2.patch
Patch13:	x-logdrake.patch
Patch14:	tinyme-x-scannerdrake.patch
Patch15:	x-sound.pm.patch
Patch16:	x-finishinstall.xsteup.patch
Patch17:	drakxtools-pam_ccreds-disable.patch
Patch18:	tinyme-drakxtools-fix-drakbug-path.patch
Patch19:	drakxtools-autologin-kde3.5.10.patch

BuildRequires:	gettext
BuildRequires:	ldetect-devel >= 0.7.0
BuildRequires:	ncurses-devel
BuildRequires:	perl-devel >= 5.10.0
BuildRequires:	perl-MDK-Common >= 1.2.3
BuildRequires:	drakx-installer-binaries
BuildRequires:	intltool

Requires:	perl-Gtk2 >= 1.072
Requires:	perl-Glib >= 1.072
Requires:	usermode >= 1.94
Requires:	perl-MDK-Common >= 1.2.3
Requires:	perl-Net-DBus
Requires:	font-tools
Requires:	libxxf86misc

Requires:	printerdrake >= 1.6.8
Requires:	drak3d >= 1.15
Requires:	drakbackup >= 0.17
Requires:	drakx-kbd-mouse-x11 >= 0.57
Requires:	drakx-net >= 0.33

Obsoletes:	draksec
Provides:	draksec
Obsoletes:	drakxtools
Provides:	drakxtools = %{version}-%{release}

%define _requires_exceptions perl(Net::FTP)\\|perl(Time::localtime)\\|perl(URPM)\\|perl(Xconfig.*)

%package newt
Summary:	The drakxtools (diskdrake, ...)
Group:		System/Configuration/Other

Requires:	perl-base >= 5.10.0
Requires:	usermode-consoleonly >= 1.44
Requires:	perl-Locale-gettext >= 1.05
Requires:	module-init-tools

Obsoletes:	diskdrake
Obsoletes:	kbdconfig
Obsoletes:	mouseconfig
Obsoletes:	setuptool
Obsoletes:	drakfloppy
Obsoletes:	drakxtools-newt

Provides:	diskdrake
Provides:	kbdconfig
Provides:	mouseconfig
Provides:	setuptool
Provides:	drakfloppy = %{version}-%{release}
Provides:	drakxtools-newt = %{version}-%{release}

Provides:	perl(ctxhelp)

%package backend
Summary:	Drakxtools libraries and background tools
Group:		System/Configuration/Other
Requires:	dmidecode
Requires:	perl-File-FnMatch
Requires:	perl-suid
Requires:	perl-String-ShellQuote
Obsoletes:	drakxtools-backend
Provides:	drakxtools-backend = %{version}-%{release}

%package http
Summary:	The drakxtools via http
Group:		System/Configuration/Other
Requires:	drakxtools-newt
Requires:	perl(Net::SSLeay) >= 1.22-1
Requires:	perl-Authen-PAM >= 0.14-1
Requires:	perl-CGI >= 2.91-1
Requires(pre):	rpm-helper
Requires(post):	rpm-helper
Obsoletes:	drakxtools-http
Provides:	drakxtools-http = %{version}-%{release}

%package -n drakx-finish-install
Summary:	First boot configuration
Group:		System/Configuration/Other
Obsoletes:	drakx-finish-install
Provides:	drakx-finish-install = %{version}-%{release}

%package -n harddrake
Summary:	Main Hardware Configuration/Information Tool
Group:		System/Configuration/Hardware
Requires:	%{name}-newt = %{version}-%{release}
Requires(pre):	rpm-helper
Requires(post):	rpm-helper
Obsoletes:	kudzu
Obsoletes:	kudzu-devel
Provides:	kudzu = %{version}
Provides:	kudzu-devel = %{version}
Obsoletes:	harddrake
Provides:	harddrake = %{version}-%{release}

%package -n harddrake-ui
Summary:	Main Hardware Configuration/Information Tool
Group:		System/Configuration/Hardware
Requires:	%{name} = %{version}-%{release}
Requires:	sane-backends
Obsoletes:	harddrake-ui
Provides:	harddrake-ui = %{version}-%{release}

%description
Contains many Mandriva and PCLinuxOS Linux applications simplifying users and
administrators life on a Mandriva and PCLinuxOS Linux machine. Nearly all of
them work both under XFree (graphical environment) and in console
(text environment), allowing easy distant work.

- drakbug: interactive bug report tool
- drakbug_report: help find bugs in DrakX
- drakclock: date & time configurator
- drakfloppy: boot disk creator
- drakfont: import fonts in the system
- draklog: show extracted information from the system logs
- drakperm: msec GUI (permissions configurator)
- draksec: security options managment / msec frontend
- draksplash: bootsplash themes creation

%description backend
See package %{name}

%description newt
Contains many Mandriva and PCLinuxOS Linux applications simplifying users and
administrators life on a Mandriva and PCLinuxOS Linux machine. Nearly all of
them work both under XFree (graphical environment) and in console
(text environment), allowing easy distant work.

- adduserdrake: help you adding a user
- diskdrake: DiskDrake makes hard disk partitioning easier. It is
  graphical, simple and powerful. Different skill levels are available
  (newbie, advanced user, expert). It's written entirely in Perl and
  Perl/Gtk. It uses resize_fat which is a perl rewrite of the work of
  Andrew Clausen (libresize).
- drakauth: configure authentification (LDAP/NIS/...)
- drakautoinst: help you configure an automatic installation replay
- drakboot: configures your boot configuration (Lilo/GRUB,
  Bootsplash, X, autologin)
- drakkeyboard: configure your keyboard (both console and X)
- draklocale: language configurator, available both for root
  (system wide) and users (user only)
- drakmouse: autodetect and configure your mouse
- drakscanner: scanner configurator
- draksound: sound card configuration
- drakx11: menu-driven program which walks you through setting up
  your X server; it autodetects both monitor and video card if
  possible
- drakxservices: SysV services and daemons configurator
- drakxtv: auto configure tv card for xawtv grabber
- lsnetdrake: display available nfs and smb shares
- lspcidrake: display your pci information, *and* the corresponding
  kernel module

%description http
This add the capability to be runned behind a web server to the drakx tools.
See package %{name}


%description -n drakx-finish-install
For OEM-like duplications, it allows at first boot:
- network configuration
- creating users
- setting root password
- choosing authentication


%description -n harddrake
The harddrake service is a hardware probing tool run at system boot
time to determine what hardware has been added or removed from the
system.
It then offer to run needed config tool to update the OS
configuration.


%description -n harddrake-ui
This is the main configuration tool for hardware that calls all the
other configuration tools.
It offers a nice GUI that show the hardware configuration splitted by
hardware classes.


%prep
%setup -q -n %{name}-%{realver}

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p0

%build
%make -C perl-install CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT

%make -C perl-install PREFIX=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/{%_initrddir,%{_sysconfdir}/{X11/xinit.d,X11/wmsession.d,sysconfig/harddrake2}}
touch $RPM_BUILD_ROOT/etc/sysconfig/harddrake2/previous_hw

dirs1="usr/lib/libDrakX usr/share/libDrakX"
(cd $RPM_BUILD_ROOT ; find $dirs1 usr/bin usr/sbin ! -type d -printf "/%%p\n")|egrep -v 'bin/.*harddrake' > %{name}.list
(cd $RPM_BUILD_ROOT ; find $dirs1 -type d -printf "%%%%dir /%%p\n") >> %{name}.list

perl -ni -e '/dbus_object\.pm|Xdrakres|clock|drak(bug|clock|floppy|font|hosts|log|perm|sec|splash)|gtk|icons|logdrake|pixmaps|\.png$/ ? print STDERR $_ : print' %{name}.list 2> %{name}-gtk.list
perl -ni -e '/http/ ? print STDERR $_ : print' %{name}.list 2> %{name}-http.list
perl -ni -e 'm!lib/libDrakX|bootloader-config|fileshare|lsnetdrake|drakupdate_fstab|rpcinfo|serial_probe! && !/curses/i ? print STDERR $_ : print' %{name}.list 2> %{name}-backend.list
perl -ni -e '/finish-install/ ? print STDERR $_ : print' %{name}.list 2> finish-install.list

#mdk menu entry
mkdir -p $RPM_BUILD_ROOT%{_datadir}/autostart

cat > $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit.d/harddrake2 <<EOF
#!/bin/sh
exec /usr/share/harddrake/service_harddrake X11
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/harddrake2/kernel <<EOF
KERNEL=2.6
EOF

mv $RPM_BUILD_ROOT%{_sbindir}/service_harddrake_confirm $RPM_BUILD_ROOT%{_datadir}/harddrake/confirm

chmod +x $RPM_BUILD_ROOT{%{_datadir}/harddrake/{conf*,service_harddrake},%{_sysconfdir}/X11/xinit.d/harddrake2}
# temporary fix until we reenable this feature
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit.d/harddrake2

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.preload.d
echo floppy > $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.preload.d/floppy

perl -I perl-install -mharddrake::data -e 'print "DETECT_$_->{class}=yes\n" foreach @harddrake::data::tree' |sort > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/harddrake2/service.conf

# consolehelper config
#

# - console user, no password
for pak in drakclock drakkeyboard drakmouse; do
        ln -s %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
        mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps/
        cat > %{buildroot}%{_sysconfdir}/security/console.apps/$pak <<EOF
USER=<user>
PROGRAM=%{_sbindir}/$pak
FALLBACK=false
SESSION=true
EOF
        mkdir -p %{buildroot}%{_sysconfdir}/pam.d/
        ln -sf %{_sysconfdir}/pam.d/mandriva-console-auth %{buildroot}%{_sysconfdir}/pam.d/$pak
done

# console user, ask for user password
for pak in drakfont; do
        ln -s %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
        mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps/
        cat > %{buildroot}%{_sysconfdir}/security/console.apps/$pak <<EOF
USER=<user>
PROGRAM=%{_sbindir}/$pak
FALLBACK=false
SESSION=true
EOF
        mkdir -p %{buildroot}%{_sysconfdir}/pam.d/
        ln -sf %{_sysconfdir}/pam.d/mandriva-simple-auth %{buildroot}%{_sysconfdir}/pam.d/$pak
done

# console user, ask for root password
for pak in drakups drakauth draklog drakxservices drakboot; do
        ln -s %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
        mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
        cat > %{buildroot}%{_sysconfdir}/security/console.apps/$pak <<EOF
USER=root
PROGRAM=/usr/sbin/$pak
FALLBACK=false
SESSION=true
EOF
        mkdir -p %{buildroot}%{_sysconfdir}/pam.d
        ln -sf %{_sysconfdir}/pam.d/mandriva-simple-auth %{buildroot}%{_sysconfdir}/pam.d/$pak
done

%find_lang libDrakX
%find_lang libDrakX-standalone
cat libDrakX.lang libDrakX-standalone.lang >> %{name}.list

rm -rf %{buildroot}%{_libdir}/libDrakX/do_pkgs.pm
install -m644 %{SOURCE1} %{buildroot}/%{_libdir}/libDrakX/do_pkgs.pm

%clean
rm -rf $RPM_BUILD_ROOT

%post
%make_session
[[ ! -e %{_sbindir}/kbdconfig ]] && %__ln_s -f keyboarddrake %{_sbindir}/kbdconfig
[[ ! -e %{_sbindir}/mouseconfig ]] && %__ln_s -f mousedrake %{_sbindir}/mouseconfig
:

%postun
%make_session
for i in %{_sbindir}/kbdconfig %{_sbindir}/mouseconfig %_bindir/printtool;do
    [[ -L $i ]] && %__rm -f $i
done
:

%post http
%_post_service drakxtools_http

%preun http
%_preun_service drakxtools_http

%post newt
%update_menus

%postun newt
%clean_menus

%post -n harddrake-ui
%update_menus

%postun -n harddrake-ui
%clean_menus

%post -n harddrake
%_post_service harddrake

%preun -n harddrake
%_preun_service harddrake

%postun -n harddrake
file /etc/sysconfig/harddrake2/previous_hw | fgrep -q perl && %{_datadir}/harddrake/convert || :

%files backend -f %{name}-backend.list
%defattr(-,root,root)
%config(noreplace) /etc/security/fileshare.conf
%attr(4755,root,root) %{_sbindir}/fileshareset
%{_sysconfdir}/modprobe.preload.d/floppy

%files newt -f %{name}.list
%defattr(-,root,root)
%{_datadir}/applications/localedrake*.desktop
%doc perl-install/diskdrake/diskdrake.html
%{_iconsdir}/localedrake.png
%{_iconsdir}/large/localedrake.png
%{_iconsdir}/mini/localedrake.png
%{_bindir}/drakkeyboard
%{_bindir}/drakmouse
%{_bindir}/drakups
%{_bindir}/drakauth
%{_bindir}/draklog
%{_bindir}/drakxservices
%{_bindir}/drakboot
%config(noreplace) %{_sysconfdir}/security/console.apps/drakkeyboard
%config(noreplace) %{_sysconfdir}/security/console.apps/drakmouse
%config(noreplace) %{_sysconfdir}/security/console.apps/drakups
%config(noreplace) %{_sysconfdir}/security/console.apps/drakauth
%config(noreplace) %{_sysconfdir}/security/console.apps/draklog
%config(noreplace) %{_sysconfdir}/security/console.apps/drakxservices
%config(noreplace) %{_sysconfdir}/security/console.apps/drakboot
%config(noreplace) %{_sysconfdir}/pam.d/drakkeyboard
%config(noreplace) %{_sysconfdir}/pam.d/drakmouse
%config(noreplace) %{_sysconfdir}/pam.d/drakups
%config(noreplace) %{_sysconfdir}/pam.d/drakauth
%config(noreplace) %{_sysconfdir}/pam.d/draklog
%config(noreplace) %{_sysconfdir}/pam.d/drakxservices
%config(noreplace) %{_sysconfdir}/pam.d/drakboot

%files -f %{name}-gtk.list
%defattr(-,root,root)
%{_bindir}/drakclock
%{_bindir}/drakfont
%config(noreplace) %{_sysconfdir}/security/console.apps/drakclock
%config(noreplace) %{_sysconfdir}/security/console.apps/drakfont
%config(noreplace) %{_sysconfdir}/pam.d/drakclock
%config(noreplace) %{_sysconfdir}/pam.d/drakfont

%files -n harddrake
%defattr(-,root,root)
%{_initrddir}/harddrake
%dir %{_sysconfdir}/sysconfig/harddrake2/
%config(noreplace) %{_sysconfdir}/sysconfig/harddrake2/previous_hw
%config(noreplace) %{_sysconfdir}/sysconfig/harddrake2/service.conf
%config(noreplace) %{_sysconfdir}/sysconfig/harddrake2/kernel
%dir %{_datadir}/harddrake/
%{_datadir}/harddrake/*
%{_sysconfdir}/X11/xsetup.d/??notify-x11-free-driver-switch.xsetup
#%{_sysconfdir}/X11/xinit.d/harddrake2

%files -n harddrake-ui
%defattr(-,root,root)
%dir /etc/sysconfig/harddrake2/
%{_sbindir}/harddrake2
%{_datadir}/pixmaps/harddrake2
%{_datadir}/applications/harddrake.desktop
%{_iconsdir}/large/harddrake.png
%{_iconsdir}/mini/harddrake.png
%{_iconsdir}/harddrake.png

%files -n drakx-finish-install
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/finish-install
%{_sysconfdir}/X11/xsetup.d/??finish-install.xsetup
%{_sbindir}/finish-install

%files http -f %{name}-http.list
%defattr(-,root,root)
%dir %{_sysconfdir}/drakxtools_http
%config(noreplace) %{_sysconfdir}/pam.d/miniserv
%{_sysconfdir}/init.d/drakxtools_http
%config(noreplace) %{_sysconfdir}/drakxtools_http/conf
%config(noreplace) %{_sysconfdir}/drakxtools_http/authorised_progs
%config(noreplace) %{_sysconfdir}/logrotate.d/drakxtools-http

%changelog
* Fri Jan 30 2009 KDulcimer <kdulcimer@gmail.com> 11-16-5tinyme2008
- fix patches

* Mon Jan 19 2009 KDulcimer <kdulcimer@gmail.com> 11-16-4tinyme2008
- Import to TinyMe
- clean up spec

* Wed Dec 17 2008 Gettinther <gettinther@gmail.com> 11-16-4pclos2007
- Fix autologin issue (patch19)

* Tue Dec 09 2008 Gettinther <gettinther@gmail.com> 11-16-3pclos2007
- Fix drakbug link

* Sun Oct 26 2008 Gettinther <gettinther@gmail.com> 11-16-2pclos2007
- Disable pam_ccreds (it's optional anyway) for the time being.

* Thu Aug 21 2008 Gettinther <gettinther@gmail.com> 11-16-1pclos2007
- Updated to latest to fix so crash errors
- Added source1 (re-use older version of do_pkgs.pm to prevent urpm issue)

* Wed Jun 25 2008 Texstar <texstar@gmail.com> 10.29.7-2pclos2007
- fix finish-install per etjr

* Wed Jun 25 2008 Texstar <texstar@gmail.com> 10.29.7-1pclos2007
- update to 10.29.7 to sync with mandriva
- fix harddrake not to start at update

+ Revision: 214757
- 10.29.7
- list hso driver in network/cellular
- 10.29.6
- do open bug in running firefox drakbug (#31109)
- allow mounting ntfs-3g partitions
  (also fixes detection of Windows partitions during live installation)
- service_harddrake:
  o do not allow fbdev if /proc/fb is empty
  o fix kbluetooth config path
  o fix autoconfiguration of harddisks
- use UUID for resume= kernel parameter
- partitioning wizard: do not propose to resize "hidden" fat partitions

  + Thierry Vignaud <tvignaud@mandriva.com>
    - draksound:
      o typo fix (#40796)
    - draksound:
      o advise to log out if PA is enabled/disabled
      o make sure that switch alsa-plugins-pulseaudio is installed when
        enabling PA routing (#40533)
    - draksound:
      o disable PA routing when PA is disabled (#40219)
      o grey PA routing & 5.1 sound if PA is disabled

  + Pixel <pixel@mandriva.com>
    - 10.29.2:
    - bootloader-config:
      o do not detect device.map inconsistency when "/boot" (or "/") is on Linux
        software raid (/dev/mdX), cf #28309 and #35714
    - 10.29.1:
    - bootloader-config:
      o fix detecting device.map inconsistency when "/boot" and "/" are not on
        same "drive" (esp. when "/" is LVM and "/boot" is not, #39229)
    - drakupdate_fstab:
      o only add formatted partitions in fstab (or else it will make
        subsequent boot fail)

* Sun Jun 01 2008 Texstar <texstar@gmail.com> 10.29.2-4pclos2007
- disable pulse audio configuration for now

* Tue May 28 2008 Texstar <texstar@gmail.com> 10.29.2-3pclos2007
- apply standalone patches

* Tue May 28 2008 Texstar <texstar@gmail.com> 10.29.2-2pclos2007
- apply module patches

* Fri May 16 2008 Texstar <texstar@gmail.com> 10.29.2-1pclos2007
- sync to mdv 2008.1
- initial build for pclinuxos 2007
- the fun begins
